%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Elm_list = Get_Elements_From_Nodes(Node_list, Excluded_elements)

% Существование узлов из списка Node_list должно проверяться вне данной функции до ее вызова
% Существование элементов из списка Excluded_elements должно проверяться вне данной функции до ее вызова

global DB_ELEMENTS;
global AST_NODES;
global AT_NODES;

if (isempty(Node_list))
    Elm_list = [];
    return;
end

if (isempty(DB_ELEMENTS))
    Elm_list = [];
    return;
end

if (isempty(AST_NODES))
    Elm_list = [];
    return;
end

Node_list = unique(Node_list);
Excluded_elements = unique(Excluded_elements);
	
counter = 0;

for i=1:size(Node_list,1)
    counter = counter + size(AST_NODES{AT_NODES(Node_list(i))}.Elm_list,1);
end

if (counter == 0)
    Elm_list = [];
    return;
end

Elm_list = zeros(counter,1);
counter = 0;

for i=1:size(Node_list,1)

    for j=1:size(AST_NODES{AT_NODES(Node_list(i))}.Elm_list,1)
        counter = counter + 1;
        Elm_list(counter) = AST_NODES{AT_NODES(Node_list(i))}.Elm_list(j);
    end

end

Elm_list = unique(Elm_list);

Elm_list = setdiff(Elm_list, Excluded_elements);

if (isempty(Elm_list))
	Elm_list = [];
end
